<template>
  <form
    class="login step1"
    @submit.prevent="sendCode"
    novalidate
    v-if="!codeSend"
  >
    <img class="img" src="../../assets/logo.png" />
    <!--novalidate = disable browser validation -->
    <h2 class="login-title" tabindex="-1">Login</h2>
    <FormField
      id="Telefoonnummer"
      inputType="tel"
      placeholder="+32483992283"
      maxLength="12"
      v-model.trim="phoneNumber"
      :error="phoneNumberError"
      :required="true"
      class="formField"
    ></FormField>
    <div class="buttons">
      <ActionButton type="submit">Volgende ></ActionButton>
    </div>
    <span class="serverError" v-if="serverError">{{ serverError }}</span>
  </form>

  <form
    class="login step2"
    @submit.prevent="tryLogin"
    novalidate
    v-if="codeSend"
  >
    <h2 class="login-title" tabindex="-1">Login</h2>
    <FormField
      id="code"
      inputType="password"
      placeholder="427334"
      maxLength="6"
      v-model.trim="code"
      :error="codeError"
      :required="true"
    ></FormField>
    <div class="buttons">
      <ActionButton type="submit">Login</ActionButton>
    </div>
    <span class="serverError" v-if="serverError">{{ serverError }}</span>
  </form>
</template>

<script>
import FormField from "../molecules/FormField.vue";
import ActionButton from "../atoms/ActionButton.vue";
import store from "../../store/auth.js";

export default {
  components: { FormField, ActionButton },
  data() {
    return {
      phoneNumber: "",
      code: "",
      codeSend: false,
      secret: null,
      submitted: false,
      serverError: null,
      press: false,
    };
  },
  computed: {
    phoneNumberError() {
      let error;
      let substring = this.phoneNumber.substring(1);
      if (!this.press) {
        error = null;
      } else if (this.phoneNumber === "") {
        error = "Telefoonnummer is verplicht!";
      } else if (
        this.phoneNumber.length !== 12 ||
        this.phoneNumber.charAt(0) !== "+" ||
        !/^\d+$/.test(substring)
      ) {
        error = "Telefoonnummer niet het juiste formaat";
      }
      return error;
    },
    codeError() {
      let error;
      if (!this.submitted) {
        error = null;
      } else if (this.code === "") {
        error = "Code is verplicht!";
      } else if (!/^\d+$/.test(this.code)) {
        error = "Code bestaat uit alleen nummers";
      }
      return error;
    },
  },
  methods: {
    async sendCode() {
      this.serverError = null;
      this.press = true;
      store.commit("general/setLoading", true);
      if (this.phoneNumberError == null) {
        try {
          const result = await store.dispatch("auth/sendCode", {
            phoneNumber: this.phoneNumber,
          });
          if (result.status === 200) {
            this.codeSend = true;
            console.log(result);
            this.secret = result.data.clientSecret;
          }
        } catch (error) {
          console.log(error);
          if (error.code === "ERR_NETWORK") {
            this.serverError = "Dienst tijdelijk niet beschikbaar";
          } else if (error.response.status === 401) {
            this.serverError = "Telefoonnummer of Code is verkeerd";
          } else {
            this.serverError = "Telefoonnummer of Code is verkeerd";
          }
        }
      }
      store.commit("general/setLoading", false);
    },
    async tryLogin() {
      this.serverError = null;
      this.submitted = true;
      store.commit("general/setLoading", true);
      if (this.phoneNumberError == null && this.codeError == null) {
        try {
          const result = await store.dispatch("auth/login", {
            phoneNumber: this.phoneNumber,
            clientSecret: this.secret,
            code: this.code,
          });
          if (result.status === 200) {
            this.$router.push({ name: "home" });
          }
        } catch (error) {
          console.log(error);
          if (error.code === "ERR_NETWORK") {
            this.serverError = "Dienst tijdelijk niet beschikbaar";
          } else if (error.response.status === 401) {
            this.serverError = "Telefoonnummer of Code is verkeerd";
          } else {
            this.serverError = "Telefoonnummer of Code is verkeerd";
          }
        }
      }
      store.commit("general/setLoading", false);
    },
  },
};
</script>

<style lang="scss">
.img {
  width: 15rem;
  align-self: center;
  padding-top: 1rem;
}
.login-title {
  text-align: center;
  align-self: center;
  width: 20rem;
  color: white;
  font-size: 40px;
  background-color: #383838;
}
.buttons {
  display: flex;
  flex-direction: row;
  align-self: center;
  width: 20rem;
  justify-content: right;
  align-items: center;
  margin: 0.5rem;
}
.FormField {
  align-self: center;
  width: 20rem;
}
.login {
  display: flex;
  flex-direction: column;
  background-color: #383838;
  color: white;
  border: solid 0.2rem #ffff00;
  margin: 10% 20%;
  border-radius: 0.4rem;
}
.serverError {
  color: red;
  padding-bottom: 1rem;
  text-align: center;
}
</style>
